#!/usr/bin/python

##   Quack
##   Copyright (C) 2007 Mads Villadsen <maxximum@krakoa.dk>
    
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 2 of the License, or
##   (at your option) any later version.
   
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
   
##   You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
##   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import os, sys

try:
    import pynotify # notify-python
except:
    print "pynotify not found"
    sys.exit(1)

try:
    import pygtk
    pygtk.require ("2.0")
    import gtk, gtk.glade, gnome, gnome.ui, gobject, gnomeapplet
except:
    print "pyGTK 2.0 not found."
    sys.exit(1)


from globals import *
import jaikuapp

sys.path.append("/usr/local/share/" + name + "/")
app = None

class quackApplet(gnomeapplet.Applet):
    def change_background(self, panelapplet, backgroundtype, color, pixmap):
        self.applet.modify_bg(gtk.STATE_NORMAL, color)
        self.box.modify_bg(gtk.STATE_NORMAL, color)

        if pixmap is not None:
            s1 = self.applet.get_style()
            s2 = self.box.get_style()
            s1.bg_pixmap[gtk.STATE_NORMAL] = pixmap
            s2.bg_pixmap[gtk.STATE_NORMAL] = pixmap


    def change_orientation(self,arg1,data):
        self.orientation = self.applet.get_orient()

        self.inside_applet.remove(self.icon)
        self.inside_applet.remove(self.label)
        self.box.remove(self.inside_applet)
        
        if self.orientation == 2 or self.orientation == 3:
            self.inside_applet = gtk.VBox()
        else:
            self.inside_applet = gtk.HBox()

            self.inside_applet.pack_start(self.icon)
            self.inside_applet.pack_start(self.label)
            self.inside_applet.show_all()
            self.box.add(self.inside_applet)

    def update_text(self):
        self.label.set_text("Quack")

    def update_tooltip(self):
        self.tooltip.set_tip(self.applet, "Quack")

    def update_icon(self):
        self.icon.hide()        

    def create_applet(self):
        app_window = self.applet

        event_box = gtk.EventBox()
        event_box.set_events(gtk.gdk.BUTTON_PRESS_MASK |
                             gtk.gdk.POINTER_MOTION_MASK |
                             gtk.gdk.POINTER_MOTION_HINT_MASK |
                             gtk.gdk.CONFIGURE )

        self.icon = gtk.Image()
        self.update_icon()

        self.label = gtk.Label()
        self.update_text()

        self.inside_applet = gtk.HBox()
        self.inside_applet.pack_start(self.icon)
        self.inside_applet.pack_start(self.label)

        self.tooltip = gtk.Tooltips()
        self.update_tooltip()

        event_box.add(self.inside_applet)
        event_box.connect("button-release-event", self.button_released)

        app_window.add(event_box)
        app_window.show_all()

        return event_box


    def __init__(self,applet,iid):
        self.__gobject_init__()
        self.applet = applet

        self.box = self.create_applet()
        self.change_orientation(None, None)
        self.update_icon()

        self.applet.connect("change_background", self.change_background)
        self.applet.connect("change-orient", self.change_orientation)

    def button_released(self, widget, event):
        #print "released : " + str(event)
        if (app != None):
            if (app.is_hidden()):
                app.show()
            else:
                app.hide()



def quack_factory(applet, iid):
    quackApplet(applet, iid)
    return True

if __name__ == "__main__":
    if (not(os.path.exists(basedir))):
        os.mkdir(basedir)

    gnome.init(program_name, program_version)
    # initialize threading
    gtk.gdk.threads_init()

    # initialize notifications
    pynotify.init(program_name)

    if (len(sys.argv) == 2 and sys.argv[1] == "--run-in-window"):
        fake_parent_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        fake_parent_window.set_title("Quack Applet")
        fake_parent_window.connect("destroy", gtk.main_quit)
        applet = gnomeapplet.Applet()
        
        app = jaikuapp.JaikuApp(True)
        quack_factory(applet, None)

        applet.reparent(fake_parent_window)
        fake_parent_window.show_all()
        gtk.main()
        app.shutdown_threads()
        sys.exit()
    elif (len(sys.argv) == 2 and sys.argv[1] == "--applet"):
        gobject.type_register(quackApplet)
        app = jaikuapp.JaikuApp(True)
        gnomeapplet.bonobo_factory("OAFIID:GNOME_Quack_Factory",
                                   quackApplet.__gtype__,
                                   "Quack applet", program_version, quack_factory)
        app.shutdown_threads()
        sys.exit()
    else:
        app = jaikuapp.JaikuApp(False)
        gtk.main()
